require(['config'], function() {
	require([
	], function($) {
		pageObj.init();
	});
});

/********************************************************
--------------------------------------------------------
- Object 목록								            -
--------------------------------------------------------
* const gridColModel = {}	: 화면 Grid Object			*
* let pageObj = {}			: 화면공통 Object			*
* let listObj = {}			: 목록화면 Object			*
* let viewObj = {}			: 상세화면 Object			*
* let modifyObj = {}		: 수정화면 Object			*
* let createObj = {}		: 신규화면 Object			*
*******************************************************/

/*화면 변수*/
const POMNG05010_GRID_ID = '#ITP_POMNG05010_jqGrid';
const POMNG05010_GRID_LIST = '#ITP_POMNG05010_jqGrid_list';
const POMNG05010_GRID_PAGER = '#ITP_POMNG05010_jqGridPager';
const POMNG05010_GRID_EMPTY = '#ITP_POMNG05010_jqGridEmpty';

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/pomng/inoutmng/deli-grid-list';// 목록
let API_DETAIL_INFO 		= '/api/pomng/inoutmng/info-inv';	// 상세

/*화면 Grid ColModel*/
const gridColModel = {
		list: [
			{
				index: 'Brand_ID', name: 'brandId',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.brandId, 		//브랜드아이디
				width: '18', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: true				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'Brand_Nm', name: 'brandNm',			//정렬가능 여부,화면표시 여부
				label: ITP_MSG_LOCALE.label.brandNm, 		//브랜드이름
				width: '20', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부	
			},
			{
				index: 'DLV_STTMT_NO', name: 'dlvSttmtUnqNo',	//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvSttmtUnqNo, 		//납품서번호
				width: '20', fixed: false, align: 'center',		// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false					//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_ST_CD', name: 'dlvStCd',		//서버로 전송시 데이터 명 , 데이터명
				label: '납품상태', 								//납품서상태
				width: '12', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'PODR_REG_DT', name: 'podrRegDt',	//서버로 전송시 데이터 명 , 데이터명
				label: '수주일자', 								//수주일자
				width: '14', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_REQ_DT', name: 'dlvReqDt',		//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvReqDt, 		//납품요청일
				width: '14', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_SCH_DT', name: 'dlvSchDt',		//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvSchDt, 		//납품예정일
				width: '14', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_CMPLT_DT', name: 'dlvCmpltDt',	//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvCmpltDt, 	//납품완료일
				width: '10', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'ITEM_ID', name: 'itemId',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.itemId, 		//품목번호
				width: '11', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'ITEM_NM', name: 'itemNm',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.itemNm, 		//품목명
				width: '10', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'PODR_QTY', name: 'podrQty',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.podrQty, 		//수주수량
				width: '6', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_QTY', name: 'dlvQty',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvQty, 		//납품수량
				width: '6', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'UNIT', name: 'unit',				//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.unit, 			//납품수량
				width: '6', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'UNIT_AMT', name: 'unitAmt',			//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.unitAmt, 		//납품금액
				width: '6', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'WHS_NM', name: 'whsNm',				//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.whsNm, 			//납품장소
				width: '6', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_MGR_NM', name: 'dlvMgrNm',		//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvMgrNm, 		//납품담당자
				width: '8', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			},
			{
				index: 'DLV_MGR_TEL_NO', name: 'dlvMgrTelNo',	//서버로 전송시 데이터 명 , 데이터명
				label: ITP_MSG_LOCALE.label.dlvMgrTelNo, 	//납품담당연락처
				width: '10', fixed: false, align: 'center',	// cell가로넓이,고정 여부 ,text정렬 
				sortable: false, hidden: false				//정렬가능 여부,화면표시 여부
			}
	]
};

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
	},
	ui: {
		init: function () {
			this.view();
			listObj.init();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('POMNG05010');

			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});
		},
	},
	event: {
		init: function () {
				this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_POMNG05010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_POMNG05010_NEWREG'			: listObj.button.create(); 		break;	// 신규등록 버튼
					}
				});
			});
		}
	},
	screen: function() {
		$('#ITP_FORM_POMNG05010_SEARCH_BRAND_ID').val(fn_make_user_info.get('brandId'));//input hidden 값 넣기				
		$('#ITP_FORM_POMNG05010_SEARCH_DTL_GUBUN').val(('dtlGubun'));
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
			this.grid.init();
	},
	itp_POMNG05010_search: false,
	button: {
			search: function() {
					listObj.itp_POMNG05010_search = true;
					let param = $('#ITP_FORM_POMNG05010_SEARCH').serializeObject();
					param.gridSize = $.jgrid.defaults.rowNum;
					param.gridPage = $.jgrid.defaults.page;
					$(POMNG05010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
			},
			create: function() {
					if(!fn_make_user_info.isEmpty()) {
					}
			}
	},
	empty: {
			init: function() {
					var _this = this;
					this.push();
					$(POMNG05010_GRID_EMPTY).on('click', function() {
							_this.back();
							_this.itp_POMNG05010_param.gridSize = $.jgrid.defaults.rowNum;
							$(POMNG05010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_POMNG05010_param)}).trigger('reloadGrid');
					});
			},
			itp_POMNG05010_param: {},
			push: function() {
					let param = $('#ITP_FORM_POMNG05010_SEARCH').serializeObject();
					listObj.itp_POMNG05010_param = param;
			},
			back: function() {
					$('#ITP_FORM_POMNG05010_SERVICE_ST_CD').val(this.itp_POMNG05010_param.sitemStCd);
					$('#ITP_FORM_POMNG05010_SEARCH_PODR_PSSBL_DVSN').val(this.itp_POMNG05010_param.spodrPssblDvsn);
					$('#ITP_FORM_POMNG05010_SEARCH_SPPLY_NM').val(this.itp_POMNG05010_param.sspplyNm);
					$('#ITP_FORM_POMNG05010_SEARCH_DLV_PLACE').val(this.itp_POMNG05010_param.sdlvPlace);
					$('#ITP_FORM_POMNG05010_SEARCH_ITEM_NM').val(this.itp_POMNG05010_param.sitemNm);
					
			}
	},
	grid: {
			init: function () {
					// 데이터 없을때
					listObj.empty.push();
					this.search();
			},
			colModel: gridColModel.list,
			search: function() {
				pageObj.screen();
				this.load();
			},
			load: function() {
					let param = $('#ITP_FORM_POMNG05010_SEARCH').serializeObject();
					param.gridSize = $.jgrid.defaults.rowNum;
					param.sbrandId = fn_make_user_info.get('brandId');

					var option = {
							gridId: POMNG05010_GRID_ID,
							colModel: gridColModel.list,
							param: param,
							url: DOMAIN + API_DETAIL_GRID_LIST,
							pager: POMNG05010_GRID_PAGER,
							multiselect: true, 
							loadComplete: function(data) {
									itp_fn_grid_load_complete(data, POMNG05010_GRID_ID, true, 'number', 'POMNG05010', listObj.itp_POMNG05010_search, listObj.empty, true, data.gridRecords, true);
							},
							onPaging: function(action) {
									itp_fn_grid_paging(POMNG05010_GRID_ID, action, param);
							}
					};
					itp_fn_grid_make_remote(option);
			}
	}
};

